#include "sysdep.h"
#include "bfd.h"
#include "stdint.h"
#include "libbfd.h"
#include "elf-bfd.h"
#include "elf/rl78.h"
//#include "libiberty.h"



/* Function to set the ELF flag bits.  */

static bool no_warn_mismatch = false;

void bfd_elf32_rl78_set_target_flags (bool);

void
bfd_elf32_rl78_set_target_flags (bool user_no_warn_mismatch)
{
  no_warn_mismatch = user_no_warn_mismatch;
}

/* Return the MACH for an e_flags value.  */

static int
elf32_rl78_machine (bfd * abfd)
{
  if ((elf_elfheader (abfd)->e_flags & EF_RL78_CPU_MASK) == EF_RL78_CPU_RL78)
    return bfd_mach_rl78;

  return 0;
}

static bool
green_dsp_elf_object_p (bfd * abfd)
{
  bfd_default_set_arch_mach (abfd, bfd_arch_green_dsp,
			     elf32_rl78_machine (abfd));
  return true;
}







#define ELF_ARCH		bfd_arch_green_dsp
#define ELF_MACHINE_CODE	EM_RL78
#define ELF_MAXPAGESIZE		0x1000

#define TARGET_LITTLE_SYM	green_dsp_elf32_vec
#define TARGET_LITTLE_NAME	"elf32-green-dsp"

#define elf_backend_object_p			green_dsp_elf_object_p
#define elf_symbol_leading_char                 ('_')
#define elf_backend_can_gc_sections		1

#define bfd_elf32_bfd_reloc_type_lookup		NULL
#define bfd_elf32_bfd_reloc_name_lookup		NULL

#include "elf32-target.h"
